/***************************************************************************
                          stranlz.h  -  description
                             -------------------
    begin                : Tue Jun 25 2002
    copyright            : (C) 2002 by Nobuhiro Kuroiwa
    email                : nobu@iastate.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef	STRANLZ_H
#define	STRANLZ_H

#include <string>
#include <list>

using namespace std;

typedef std::list<string> StrLst;

bool	eraseSpace(			string	*psrc									);
void	eraseString(		string	*psrc,				string	*pletter	);
void	eraseString(		string	*psrc,				char	*pletter	);
void	pealParenthesis(	string	*pstr									);
void	eraseComment(		string	*pst									);
bool	isNumber( 			string	*pstr									);
bool	loadFile(			string	*pstr_filename,		string *pstr_save	);
bool	loadFile(			char	*pchar_filename,	string *pstr_save	);

unsigned int countString(	string	*psrc,	char	*pchar_sample	);
unsigned int countString(	string	*psrc,	string	*psample		);

bool devideStringByStringEx(
								string			*pstr_src,
								string			*pstr_clv,
								list<string>	*plst_str,
								bool			care_parenthesis
);
bool devideStringByStringEx(
								string			*pstr_src,
								char			*pchar_clv,
								list<string>	*plst_str,
								bool			care_parenthesis
);

bool devideDevided(
								string			*pstr_src,
								char			*pchar_clv_high,
								char			*pchar_clv_low,
								list<StrLst>	*plst_lst_str
);
bool devideDevided(
								string			*pstr_src,
								string			*pstr_clv_high,
								string			*pstr_clv_low,
								list<StrLst>	*plst_lst_str
);

void devideStringByA2B(
								string			*pstr_src,
								string			*pstr_clv1,
								string			*pstr_clv2,
								list<string> 	*plst_str
);
void devideStringByA2B(
								string			*pstr_src,
								char			*pchar_clv1,
								char			*pchar_clv2,
								list<string>	*plst_str
);



// test functions only for debug
/*
void testEraseComment();
void testDevideStringA2B2();
void	testDevideStringByStringEx();
void	testDevideByComma();
void	testCountString();						// test function.
void	devideByCommaVSdevideStringByStringEx();
void	testPealParenthesis();
*/
#endif//	STRANLZ_H
